Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.crypto
Class KeyGenerator

    java.lang.Object
      |
      +--javax.crypto.KeyGenerator

public class KeyGenerator
extends Object

This class provides the functionality of a (symmetric) key generator.

Key generators are constructed using one of the getInstance class methods of this class.

KeyGenerator objects are reusable, i.e., after a key has been generated, the same KeyGenerator object can be re-used to generate further keys.

There are two ways to generate a key: in an algorithm-independent manner, and in an algorithm-specific manner. The only difference between the two is the initialization of the object:

Algorithm-Independent Initialization All key generators share the concepts of a "strength" and a source of randomness. The measure of strength is universally shared by all algorithms, though it is interpreted differently for different algorithms. There is an init method in this KeyGenerator class that takes these two universally shared types of arguments. There is also one that takes just a strength argument, and uses a system-provided source of randomness, and one that takes just a source of randomness. Since no other parameters are specified when you call the above algorithm-independent init methods, it is up to the provider what to do about the algorithm-specific parameters (if any) to be associated with each of the keys.

Algorithm-Specific Initialization For situations where a set of algorithm-specific parameters already exists, there are two init methods that have an AlgorithmParameterSpec argument. One also has a SecureRandom argument, while the source of randomness is system-provided for the other.

In case the client does not explicitly initialize the KeyGenerator (via a call to an init method), each provider must supply (and document) a default initialization.

See Also:
  `SecretKey`, `AlgorithmParameters`, `AlgorithmParameterSpec`

Constructor Summary
`protected` | `KeyGenerator(KeyGeneratorSpi keyGenSpi, Provider provider, String algorithm)` Creates a KeyGenerator object.

Method Summary
`SecretKey` | `generateKey()` Generates a secret key.
`String` | `getAlgorithm()` Returns the standard name of the key algorithm.
`static KeyGenerator` | `getInstance(String algorithm)` Generates a KeyGenerator object for the specified algorithm.
`static KeyGenerator` | `getInstance(String algorithm, String provider)` Generates a keyGenerator object for the specified key algorithm from the specified provider.
`Provider` | `getProvider()` Returns the provider of this KeyGenerator object.
`void` | `init(AlgorithmParameterSpec params)` Initializes the key generator with the specified parameter set and a system-provided source of randomness.
`void` | `init(AlgorithmParameterSpec params, SecureRandom random)` Initializes the key generator with the specified parameter set and a user-provided source of randomness.
`void` | `init(int strength)` Initializes this key generator for a certain strength, using a system-provided source of randomness.
`void` | `init(int strength, SecureRandom random)` Initializes this key generator for a certain strength, using the given source of randomness.
`void` | `init(SecureRandom random)` Initializes the key generator.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### KeyGenerator

    protected KeyGenerator(KeyGeneratorSpi keyGenSpi,
                           Provider provider,
                           String algorithm)

  Creates a KeyGenerator object.
  Parameters:
    `keyGenSpi` - the delegate
    `provider` - the provider
    `algorithm` - the algorithm

Method Detail

### getAlgorithm

    public final String getAlgorithm()

  Returns the standard name of the key algorithm.

  This is the same name that was specified in one of the getInstance calls that created this KeyGenerator object.

  Returns:
    the standard algorithm name.

### getInstance

    public static final KeyGenerator getInstance(String algorithm)
                                          throws NoSuchAlgorithmException

  Generates a KeyGenerator object for the specified algorithm. If the default provider package provides an implementation of the requested key generator, an instance of KeyGenerator containing that implementation is returned. If the requested key generator is not available in the default provider package, other provider packages are searched.
  Parameters:
    `algorithm` - the standard name of the requested key algorithm. See Appendix A in the Java Cryptography Extension API Specification & Reference for information about standard algorithm names.
  Returns:
    the new KeyGenerator object
  Throws:
    NoSuchAlgorithmException - if a key generator for the requested algorithm is not available in the default provider package or any of the other provider packages that were searched.

### getInstance

    public static final KeyGenerator getInstance(String algorithm,
                                                 String provider)
                                          throws NoSuchAlgorithmException,
                                                 NoSuchProviderException

  Generates a keyGenerator object for the specified key algorithm from the specified provider.
  Parameters:
    `algorithm` - the standard name of the requested key algorithm. See Appendix A in the Java Cryptography Extension API Specification & Reference for information about standard algorithm names.
    `provider` - the provider
  Returns:
    the new KeyGenerator object
  Throws:
    NoSuchAlgorithmException - if a key generator for the requested algorithm is not available
    NoSuchProviderException - if the requested provider is not available

### getProvider

    public final Provider getProvider()

  Returns the provider of this KeyGenerator object.
  Returns:
    the provider of this KeyGenerator object

### init

    public final void init(SecureRandom random)

  Initializes the key generator.
  Parameters:
    `random` - the source of randomness for this generator

### init

    public final void init(AlgorithmParameterSpec params)
                    throws InvalidAlgorithmParameterException

  Initializes the key generator with the specified parameter set and a system-provided source of randomness.
  Parameters:
    `params` - the key generation parameters
  Throws:
    InvalidAlgorithmParameterException - if the given parameters are inappropriate for this key generator

### init

    public final void init(AlgorithmParameterSpec params,
                           SecureRandom random)
                    throws InvalidAlgorithmParameterException

  Initializes the key generator with the specified parameter set and a user-provided source of randomness.
  Parameters:
    `params` - the key generation parameters
    `random` - the source of randomness
  Throws:
    InvalidAlgorithmParameterException - if the given parameters are inappropriate for this key generator

### init

    public final void init(int strength)

  Initializes this key generator for a certain strength, using a system-provided source of randomness.
  Parameters:
    `strength` - the strength of the key. This is an algorithm-specific metric specified in number of bits.

### init

    public final void init(int strength,
                           SecureRandom random)

  Initializes this key generator for a certain strength, using the given source of randomness.
  Parameters:
    `strength` - the strength of the key. This is an algorithm-specific metric specified in number of bits.
    `random` - the source of randomness

### generateKey

    public final SecretKey generateKey()

  Generates a secret key.
  Returns:
    the new key

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD